#!/bin/bash
'''
You have to install cloc, sloccount and ohcount before to execute this script.
The script have to be in the same directory of unzipped tar.gz.
'''

dirs=`ls --hide=*.sh`
for dir in ${dirs} 
do
	sloccount $dir > "$dir"_sloccount.txt
	cloc $dir > "$dir"_cloc.txt
	ohcount $dir > "$dir"_ohcount.txt
done

files=`ls | grep '_sloccount.txt'`
for file in ${files} 
do
	name=`echo $file | sed 's/\.txt//g'`
	lines=`cat $file | grep "Total Physical Source Lines of Code (SLOC)" | cut -d= -f2 | sed 's/,//g'`
	echo "$name $lines" >> loc_sloccount.txt 
done


files=`ls | grep '_cloc.txt'`
for file in ${files} 
do
	name=`echo $file | sed 's/\.txt//g'`
	lines=`cat $file | grep "SUM:" | sed 's/.*  *\([0-9][0-9]*\)$/\1/g'`
	echo "$name $lines" >> loc_cloc.txt 
done

files=`ls | grep '_ohcount.txt'`
for file in ${files} 
do
	name=`echo $file | sed 's/\.txt//g'`
	lines=`cat $file | tail -n1 | sed 's/Total *[0-9][0-9]* *\([0-9][0-9]*\).*/\1/g'`
	echo "$name $lines" >> loc_ohcount.txt 
done
