# -*- coding: utf-8 -*-
'''
Copyright (C) 2013  Héctor J. Macho Pedroso <hjmacho@outlook.com>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
'''

'''
Para poder utilizar este script es necesario tener instalado PHP Depend, el cual
se distribuye bajo licencia BSD de 3 cláusulas. Para instalarlo es necesario
tener instalado PEAR, hecho esto basta con ejecutar los siguientes comandos con
permisos de administrador:

  pear channel-discover pear.pdepend.org
  pear install pdepend/PHP_Depend
'''

import os
import re
import subprocess



def atoi(text):
    return int(text) if text.isdigit() else text

def natural_keys(text):
    return [ atoi(c) for c in re.split('(\d+)', text) ]


dirs = []
files = os.listdir('.')
for fileAux in files:
  if (os.path.isdir(fileAux)):
    dirs.append(fileAux)

dirs.sort(key=natural_keys)

if not os.path.isdir("results"):
   os.mkdir("results")

for directory in dirs:
  subprocess.call(["pdepend", "--overview-pyramid=results/"+directory+"_pyramid.svg", "--jdepend-xml=results/"+directory+"_report.xml", "--summary-xml=results/"+directory+"_summary.xml", "--jdepend-chart=results/"+directory+"_jdependchart.svg", directory])
