import os
import re
import sys


def atoi(text):
    return int(text) if text.isdigit() else text

def natural_keys(text):
    return [ atoi(c) for c in re.split('(\d+)', text) ]

def clean_path(path):
    if '/' in path:
        path = path[path.rfind('/')+1:]
    if path[-7:] == '.tar.gz':
        path = path[:-7]
    elif path[-4:] == '.tgz':    
        path = path[:-4]
    return path

fichero = sys.argv[1]

extensions = '\.tar\.gz$|\.tgz$'

tarballs = [elem for elem in os.listdir('.') if re.search(extensions, elem)]
tarballs.sort(key=natural_keys)

for i in range(len(tarballs)):
  tarballs[i] = clean_path(tarballs[i])

results = [["" for x in xrange(len(tarballs))] for x in xrange(len(tarballs))] 

projectA=""
projectB=""

f = open (fichero)
for linea in f:
  cadenas=linea.split()
  if (cadenas[0] == "Project") :
    if (cadenas[1] == "A:"):
      projectA=cadenas[2]
    else:
      projectB=cadenas[2]
  elif (cadenas[0] == "Average:") :
    results[tarballs.index(projectA)][tarballs.index(projectB)]=cadenas[1]

f.close()

csv = open("results.csv", "w")
aux = ""
for version in tarballs:
  aux=aux + ";" + version

csv.write(aux+"\n")

for i in range(len(tarballs)):
  aux = tarballs[i]
  for j in range(len(tarballs)):
    aux = aux + ";"+ results[j][i]
  csv.write(aux+"\n")
csv.close()
